package glk;

public interface Glk extends GlkConstants {

/* glk.h: Header file for Glk API, version 0.6.1.
    Designed by Andrew Plotkin <erkyrath@eblong.com>
    http://www.eblong.com/zarf/glk/index.html

    This file is copyright 1998-2000 by Andrew Plotkin. You may copy,
    distribute, and incorporate it into your own programs, by any means
    and under any conditions, as long as you do not modify it. You may
    also modify this file, incorporate it into your own programs, 
    and distribute the modified version, as long as you retain a notice
    in your program or documentation which mentions my name and the URL 
    shown above.
*/
/* This is a VERY modified version of glk.h, intended as a GLK java interface.
   It is not blessed by Andrew Plotkin or anyone else.  -- MTR */

/* You may have to edit the definition of glui32 to make sure it's really a
    32-bit unsigned integer type, and glsi32 to make sure it's really a
    32-bit signed integer type. If they're not, horrible things will happen. */
/*typedef unsigned long glui32; 
  typedef signed long glsi32; */
/* Java has no typedefs and no unsigned types.  Use 'int' for both of these 
because using a class would suck.  An implementation must endeavor to treat 
glui32's as unsigned despite this. */ 

/* These are the compile-time conditionals that reveal various Glk optional
    modules. */
/*#define GLK_MODULE_IMAGE
#define GLK_MODULE_SOUND
#define GLK_MODULE_HYPERLINKS*/
/* Java lacks compile-time conditionals.  These should probably be 
   implemented as other interfaces */

/* These types are opaque object identifiers. They're pointers to opaque
    C structures, which are defined differently by each library. */
/*typedef struct glk_window_struct  *winid_t;
typedef struct glk_stream_struct  *strid_t;
typedef struct glk_fileref_struct *frefid_t;
typedef struct glk_schannel_struct *schanid_t;*/
/* The id_t's are implemented as other interfaces.  The structs do not exist */
    
    /* glk_main() is the top-level function which you define. The Glk library
       calls it. */
    /*extern void glk_main(void);*/
    /* Java: Declare your program to implement GlkProgram instead */

    public void glk_exit();
    public void glk_set_interrupt_handler(GlkInterruptHandler inthandler);
    public void glk_tick();

    public /*glui32*/int glk_gestalt(/*glui32*/int sel, /*glui32*/int val);
    public /*glui32*/int glk_gestalt_ext(/*glui32*/int sel, /*glui32*/int val, /*glui32*/int []arr, 
    /*glui32*/int arrlen);

    public char glk_char_to_lower(char ch);
    public char glk_char_to_upper(char ch);

    public winid_t glk_window_get_root();
    public winid_t glk_window_open(winid_t split, /*glui32*/int method, /*glui32*/int size, 
    /*glui32*/int wintype, /*glui32*/int rock);
    public void glk_window_close(winid_t win, stream_result_t result);
    public glk_size glk_window_get_size(winid_t win);
    public void glk_window_set_arrangement(winid_t win, /*glui32*/int method,
    /*glui32*/int size, winid_t keywin);
    public glk_arrangement glk_window_get_arrangement(winid_t win);
    public winid_t glk_window_iterate(winid_t win); /* can't get the rock */
    public /*glui32*/int glk_window_get_rock(winid_t win);
    public /*glui32*/int glk_window_get_type(winid_t win);
    public winid_t glk_window_get_parent(winid_t win);
    public winid_t glk_window_get_sibling(winid_t win);
    public void glk_window_clear(winid_t win); 
    public void glk_window_move_cursor(winid_t win, /*glui32*/int xpos, /*glui32*/int ypos);

    public strid_t glk_window_get_stream(winid_t win);
    public void glk_window_set_echo_stream(winid_t win, strid_t str);
    public strid_t glk_window_get_echo_stream(winid_t win);
    public void glk_set_window(winid_t win);

    public strid_t glk_stream_open_file(frefid_t fileref, /*glui32*/int fmode,
    /*glui32*/int rock);
    public strid_t glk_stream_open_memory(byte[] buf, /*glui32*/int buflen, /*glui32*/int fmode,
    /*glui32*/int rock);
    public void glk_stream_close(strid_t str, stream_result_t result); 
    public strid_t glk_stream_iterate(strid_t str); /* note change: cannot get rock -- MTR*/
    public /*glui32*/int glk_stream_get_rock(strid_t str);
    public void glk_stream_set_position(strid_t str, /*glsi32*/int pos, /*glui32*/int seekmode);
    public /*glui32*/int glk_stream_get_position(strid_t str);
    public void glk_stream_set_current(strid_t str); 
    public strid_t glk_stream_get_current();

    public void glk_put_char(char ch);
    public void glk_put_char_stream(strid_t str, char ch);
    public void glk_put_string(String s);
    public void glk_put_string_stream(strid_t str, String s);
    public void glk_put_buffer(byte []buf, /*glui32*/int len);
    public void glk_put_buffer(char []buf, /*glui32*/int len);
    public void glk_put_buffer_stream(strid_t str, byte []buf, /*glui32*/int len);
    public void glk_put_buffer_stream(strid_t str, char []buf, /*glui32*/int len);
    public void glk_set_style(/*glui32*/int styl);
    public void glk_set_style_stream(strid_t str, /*glui32*/int styl);

    public int glk_get_char_stream(strid_t str);
    public /*glui32*/int glk_get_line_stream(strid_t str, char []buf, /*glui32*/int len);
    public /*glui32*/int glk_get_line_stream(strid_t str, byte []buf, /*glui32*/int len);
    public /*glui32*/int glk_get_buffer_stream(strid_t str, char []buf, /*glui32*/int len);
    public /*glui32*/int glk_get_buffer_stream(strid_t str, byte []buf, /*glui32*/int len);

    public void glk_stylehint_set(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint, 
				  /*glsi32*/int val);
    public void glk_stylehint_clear(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint);
    public /*glui32*/int glk_style_distinguish(winid_t win, /*glui32*/int styl1, /*glui32*/int styl2);
    public /*glui32*/Integer glk_style_measure(winid_t win, /*glui32*/int styl, /*glui32*/int hint); /* Interface changed for java */

    public frefid_t glk_fileref_create_temp(/*glui32*/int usage, /*glui32*/int rock);
    public frefid_t glk_fileref_create_by_name(/*glui32*/int usage, String name,
    /*glui32*/int rock);
    public frefid_t glk_fileref_create_by_prompt(/*glui32*/int usage, /*glui32*/int fmode,
    /*glui32*/int rock);
    public frefid_t glk_fileref_create_from_fileref(/*glui32*/int usage, frefid_t fref,
    /*glui32*/int rock);
    public void glk_fileref_destroy(frefid_t fref); 
    public frefid_t glk_fileref_iterate(frefid_t fref);  /* can't get the rock here */
    public /*glui32*/int glk_fileref_get_rock(frefid_t fref);
    public void glk_fileref_delete_file(frefid_t fref); 
    public /*glui32*/int glk_fileref_does_file_exist(frefid_t fref); 

    public void glk_select(event_t event); 
    public void glk_select_poll(event_t event);

    public void glk_request_timer_events(/*glui32*/int millisecs); 

    public void glk_request_line_event(winid_t win, byte []buf, /*glui32*/int maxlen,
				  /*glui32*/int initlen);
    public void glk_request_char_event(winid_t win);
    public void glk_request_mouse_event(winid_t win); 

    public void glk_cancel_line_event(winid_t win, event_t event);
    public void glk_cancel_char_event(winid_t win);
    public void glk_cancel_mouse_event(winid_t win); 
}

