package glk;
import java.util.HashMap;
public class GlkArgument
{
    public final static int type_Iu = 1;
    public final static int type_Is = 2;
    public final static int type_Cu = 3;
    public final static int type_Cs = 4;
    public final static int type_Cn = 5;
    public final static int type_S = 6;
    public final static int type_F = 7;
    public final static int type_Qa = 8;
    public final static int type_Qb = 9;
    public final static int type_Qc = 10;
    public final static int type_Qd = 11;
    public final static int type_Qz = 33;

    public int basic_type;
    public boolean isref;
    public boolean copy_in;
    public boolean copy_out;
    public boolean required;
    public boolean returnval;
    public boolean structure;
    public boolean isarray;
    public boolean retained;
    public GlkArgument []structargs;

    static HashMap typemap;
    
    static void createTypeMap()
    {
	typemap = new HashMap();
	typemap.put("Iu",new Integer(type_Iu));
	typemap.put("Is", new Integer(type_Is));
	typemap.put("Cu", new Integer(type_Cu));
	typemap.put("Cs", new Integer(type_Cs));
	typemap.put("Cn", new Integer(type_Cn));
	typemap.put("S", new Integer(type_S));
	typemap.put("F", new Integer(type_F));
	typemap.put("Qa", new Integer(type_Qa));
	typemap.put("Qb", new Integer(type_Qb));
	typemap.put("Qc", new Integer(type_Qc));
	typemap.put("Qd", new Integer(type_Qd));
    }

    public static int getBasicType(String s)
    {
	if (typemap == null)
	    createTypeMap();
	return ((Integer)typemap.get(s)).intValue();
    }

    public static GlkArgument [] CreateArgsFromString(String s) {
	int i = 0;
	char ch;

	while (Character.isDigit(ch = s.charAt(i++)));
	i--;
	int numargs = Integer.parseInt(s.substring(0, i));
	GlkArgument []args = new GlkArgument[numargs];
	for (int j = 0; j < numargs; j++) {
	    ch = s.charAt(i++);
	    args[j] = new GlkArgument();
	    while (!Character.isUpperCase(ch) && (ch != ']')) {
		switch (ch) {
		case '&': 
		    args[j].copy_in = true;
		    args[j].isref = true;
		    args[j].copy_out = true;
		    break;
		case '<':
		    args[j].isref = true;
		    args[j].copy_out = true;
		    break;
		case '>':
		    args[j].isref = true;
		    args[j].copy_in = true;
		    break;
		case '+':
		    args[j].required = true;
		    break;
		case ':':
		    args[j].returnval = true;
		    args[j].isref = true;
		    args[j].copy_out = true;
		    break;
		case '[':
		    args[j].structure = true;
		    /* does not work with nested structures */
		    int endstruct = s.indexOf(']', i);
		    args[j].structargs = CreateArgsFromString(s.substring(i, endstruct));
		    i = endstruct;
		    break;
		case '#':
		    args[j].isarray = true;
		    break;
		case '!':
		    args[j].retained = true;
		    break;
		}
		ch = s.charAt(i++);
	    }
	    if (!args[j].structure) {
		int beginbt = i - 1;
		if (Character.isLowerCase(s.charAt(i))) {
		    i++;
		}
		String basictype = s.substring(beginbt, i);
		args[j].basic_type = getBasicType(basictype);
	    }
	}
	return args;
    }
}
