package glk;
public class GlkDispatcher extends GlkProxy {
    
    private int IV(Object o)
    {
	return ((Integer)o).intValue();
    }

    private static Object NoChangeReference = new Object();

    public static Object getNoChangeReference() {
	return NoChangeReference;
    }

    public String gidispatch_prototype(int funcnum)
    {
	switch (funcnum) {
	case 0x0001: /* exit */
	    return "0:";
	case 0x0002: /* set_interrupt_handler */
	    /* cannot be invoked through dispatch layer */
	    return null;
	case 0x0003: /* tick */
	    return "0:";
	case 0x0004: /* gestalt */
	    return "3IuIu:Iu";
	case 0x0005: /* gestalt_ext */
	    return "4IuIu&#Iu:Iu";
	case 0x0020: /* window_iterate */
	    return "3Qa<Iu:Qa";
	case 0x0021: /* window_get_rock */
	    return "2Qa:Iu";
	case 0x0022: /* window_get_root */
	    return "1:Qa";
	case 0x0023: /* window_open */
	    return "6QaIuIuIuIu:Qa";
	case 0x0024: /* window_close */
	    return "2Qa<[2IuIu]:";
	case 0x0025: /* window_get_size */
	    return "3Qa<Iu<Iu:";
	case 0x0026: /* window_set_arrangement */
	    return "4QaIuIuQa:";
	case 0x0027: /* window_get_arrangement */
	    return "4Qa<Iu<Iu<Qa:";
	case 0x0028: /* window_get_type */
	    return "2Qa:Iu";
	case 0x0029: /* window_get_parent */
	    return "2Qa:Qa";
	case 0x002A: /* window_clear */
	    return "1Qa:";
	case 0x002B: /* window_move_cursor */
	    return "3QaIuIu:";
	case 0x002C: /* window_get_stream */
	    return "2Qa:Qb";
	case 0x002D: /* window_set_echo_stream */
	    return "2QaQb:";
	case 0x002E: /* window_get_echo_stream */
	    return "2Qa:Qb";
	case 0x002F: /* set_window */
	    return "1Qa:";
	case 0x0030: /* window_get_sibling */
	    return "2Qa:Qa";
	case 0x0040: /* stream_iterate */
	    return "3Qb<Iu:Qb";
	case 0x0041: /* stream_get_rock */
	    return "2Qb:Iu";
	case 0x0042: /* stream_open_file */
	    return "4QcIuIu:Qb";
	case 0x0043: /* stream_open_memory */
	    return "4&+#!CnIuIu:Qb";
	case 0x0044: /* stream_close */
	    return "2Qb<[2IuIu]:";
	case 0x0045: /* stream_set_position */
	    return "3QbIsIu:";
	case 0x0046: /* stream_get_position */
	    return "2Qb:Iu";
	case 0x0047: /* stream_set_current */
	    return "1Qb:";
	case 0x0048: /* stream_get_current */
	    return "1:Qb";
	case 0x0060: /* fileref_create_temp */
	    return "3IuIu:Qc";
	case 0x0061: /* fileref_create_by_name */
	    return "4IuSIu:Qc";
	case 0x0062: /* fileref_create_by_prompt */
	    return "4IuIuIu:Qc";
	case 0x0063: /* fileref_destroy */
	    return "1Qc:";
	case 0x0064: /* fileref_iterate */
	    return "3Qc<Iu:Qc";
	case 0x0065: /* fileref_get_rock */
	    return "2Qc:Iu";
	case 0x0066: /* fileref_delete_file */
	    return "1Qc:";
	case 0x0067: /* fileref_does_file_exist */
	    return "2Qc:Iu";
	case 0x0068: /* fileref_create_from_fileref */
	    return "4IuQcIu:Qc";
	case 0x0080: /* put_char */
	    return "1Cu:";
	case 0x0081: /* put_char_stream */
	    return "2QbCu:";
	case 0x0082: /* put_string */
	    return "1S:";
	case 0x0083: /* put_string_stream */
	    return "2QbS:";
	case 0x0084: /* put_buffer */
	    return "1>+#Cn:";
	case 0x0085: /* put_buffer_stream */
	    return "2Qb>+#Cn:"; 
	case 0x0086: /* set_style */
	    return "1Iu:";
	case 0x0087: /* set_style_stream */
	    return "2QbIu:";
	case 0x0090: /* get_char_stream */
	    return "2Qb:Iu";
	case 0x0091: /* get_line_stream */
	    return "3Qb<+#Cn:Iu"; 
	case 0x0092: /* get_buffer_stream */
	    return "3Qb<+#Cn:Iu"; 
	case 0x00A0: /* char_to_lower */
	    return "2Cu:Cu";
	case 0x00A1: /* char_to_upper */
	    return "2Cu:Cu";
	case 0x00B0: /* stylehint_set */
	    return "4IuIuIuIs:";
	case 0x00B1: /* stylehint_clear */
	    return "3IuIuIu:";
	case 0x00B2: /* style_distinguish */
	    return "4QaIuIu:Iu";
	case 0x00B3: /* style_measure */
	    return "5QaIuIu<Iu:Iu";
	case 0x00C0: /* select */
	    return "1<+[4IuQaIuIu]:";
	case 0x00C1: /* select_poll */
	    return "1<+[4IuQaIuIu]:";
	case 0x00D0: /* request_line_event */
	    return "3Qa&+#!CnIu:";
	case 0x00D1: /* cancel_line_event */
	    return "2Qa<[4IuQaIuIu]:";
	case 0x00D2: /* request_char_event */
	    return "1Qa:";
	case 0x00D3: /* cancel_char_event */
	    return "1Qa:";
	case 0x00D4: /* request_mouse_event */
	    return "1Qa:";
	case 0x00D5: /* cancel_mouse_event */
	    return "1Qa:";
	case 0x00D6: /* request_timer_events */
	    return "1Iu:";
	}
	if (glk instanceof GlkImage) {
	  switch (funcnum) {
	    /* GLK_Module_Image */
	  case 0x00E0: /* image_get_info */
	    return "4Iu<Iu<Iu:Iu";
	  case 0x00E1: /* image_draw */
	    return "5QaIuIsIs:Iu";
	  case 0x00E2: /* image_draw_scaled */
	    return "7QaIuIsIsIuIu:Iu";
	  case 0x00E8: /* window_flow_break */
	    return "1Qa:";
	  case 0x00E9: /* window_erase_rect */
	    return "5QaIsIsIuIu:";
	  case 0x00EA: /* window_fill_rect */
	    return "6QaIuIsIsIuIu:";
	  case 0x00EB: /* window_set_background_color */
	    return "2QaIu:";
	  }
	}
	if (glk instanceof GlkSound) {
	  switch(funcnum) {
	  case 0x00F0: /* schannel_iterate */
	    return "3Qd<Iu:Qd";
	  case 0x00F1: /* schannel_get_rock */
	    return "2Qd:Iu";
	  case 0x00F2: /* schannel_create */
	    return "2Iu:Qd";
	  case 0x00F3: /* schannel_destroy */
	    return "1Qd:";
	  case 0x00F8: /* schannel_play */
	    return "3QdIu:Iu";
	  case 0x00F9: /* schannel_play_ext */
	    return "5QdIuIuIu:Iu";
	  case 0x00FA: /* schannel_stop */
	    return "1Qd:";
	  case 0x00FB: /* schannel_set_volume */
	    return "2QdIu:";
	  case 0x00FC: /* sound_load_hint */
	    return "2IuIu:";
	  }
	}
	if (glk instanceof GlkHyperlink) {
	    /* GLK_MODULE_HYPERLINKS */
	    switch (funcnum) {
	    case 0x0100: /* set_hyperlink */
		return "1Iu:";
	    case 0x0101: /* set_hyperlink_stream */
		return "2QbIu:";
	    case 0x0102: /* request_hyperlink_event */
		return "1Qa:";
	    case 0x0103: /* cancel_hyperlink_event */
		return "1Qa:";
	    }
	}
	return null;
    }
    
    public void gidispatch_call(int funcnum, int numargs, Object []arglist)
    {
	int arrlen, tmpint;
	winid_t winref;

	switch (funcnum) {
	case 0x0001: /* exit */
	    glk_exit();
	    break;
	case 0x0002: /* set_interrupt_handler */
	    /* cannot be invoked through dispatch layer */
	    break;
	case 0x0003: /* tick */
	    glk_tick();
	    break;
	case 0x0004: /* gestalt */
	    tmpint = glk_gestalt(IV(arglist[0]),
				 IV(arglist[1]));
	    arglist[2] = new Integer(tmpint);
	    break;
	case 0x0005: /* gestalt_ext */
	    arrlen = (arglist[2] != null)?((int [])arglist[2]).length:0;
	    tmpint = glk_gestalt_ext(((Integer)arglist[0]).intValue(),
				     ((Integer)arglist[1]).intValue(),
				     (int [])arglist[2], arrlen);

	    arglist[3] = new Integer(tmpint);
            break;
        case 0x0020: /* window_iterate */
	    winref = glk_window_iterate((winid_t)arglist[0]);
	    arglist[2] = winref;
	    if ((arglist[1] != null) && (winref != null))
		arglist[1] = new Integer(glk_window_get_rock(winref));
            break;
        case 0x0021: /* window_get_rock */
	    tmpint = glk_window_get_rock((winid_t)arglist[0]);
	    arglist[1] = new Integer(tmpint);
            break;

        case 0x0022: /* window_get_root */
            arglist[0] = glk_window_get_root();
            break;
        case 0x0023: /* window_open */
	    System.err.println(arglist[0]);
	    System.err.println(arglist[1]);
	    System.err.println(arglist[2]);
	    System.err.println(arglist[3]);
	    System.err.println(arglist[4]);
            arglist[5] = glk_window_open((winid_t)arglist[0], 
					 IV(arglist[1]),
					 IV(arglist[2]), IV(arglist[3]),
					 IV(arglist[4]));
            break;
        case 0x0024: /* window_close */
            if (arglist[1] != null) {
                stream_result_t dat = new stream_result_t();
		Object [] structargs = (Object [])arglist[1];
                glk_window_close((winid_t)arglist[0], dat);
                structargs[0] = new Integer(dat.readcount);
                structargs[1] = new Integer(dat.writecount);
            }
            else {
                glk_window_close((winid_t)arglist[0], null);
            }
            break;
        case 0x0025: /* window_get_size */
	    glk_size winsize = glk_window_get_size((winid_t)arglist[0]);
	    if (arglist[1] != null)
		arglist[1] = new Integer(winsize.width);
	    if (arglist[2] != null)
		arglist[2] = new Integer(winsize.height);
            break;
        case 0x0026: /* window_set_arrangement */
            glk_window_set_arrangement((winid_t)arglist[0], 
				       IV(arglist[1]), 
				       IV(arglist[2]), 
				       (winid_t)arglist[3]);
            break;
        case 0x0027: /* window_get_arrangement */
	    glk_arrangement winarrange = 
                glk_window_get_arrangement((winid_t)arglist[0]);
	    if (arglist[1] != null)
		arglist[1] = new Integer(winarrange.method);
	    if (arglist[2] != null)
		arglist[2] = new Integer(winarrange.size);
	    if (arglist[3] != null)
		arglist[3] = winarrange.keywin;
            break;
        case 0x0028: /* window_get_type */
	    tmpint = glk_window_get_type((winid_t)arglist[0]);
            arglist[1] = new Integer(tmpint);
            break;
        case 0x0029: /* window_get_parent */
            arglist[1] = glk_window_get_parent((winid_t)arglist[0]);
            break;
        case 0x002A: /* window_clear */
            glk_window_clear((winid_t)arglist[0]);
            break;
        case 0x002B: /* window_move_cursor */
            glk_window_move_cursor((winid_t)arglist[0], IV(arglist[1]), 
				   IV(arglist[2]));
            break;
        case 0x002C: /* window_get_stream */
            arglist[1] = glk_window_get_stream((winid_t)arglist[0]);
            break;
        case 0x002D: /* window_set_echo_stream */
            glk_window_set_echo_stream((winid_t)arglist[0], (strid_t)arglist[1]);
            break;
        case 0x002E: /* window_get_echo_stream */
            arglist[1] = glk_window_get_echo_stream((winid_t)arglist[0]);
            break;
        case 0x002F: /* set_window */
            glk_set_window((winid_t)arglist[0]);
            break;
        case 0x0030: /* window_get_sibling */
            arglist[1] = glk_window_get_sibling((winid_t)arglist[0]);
            break;
        case 0x0040: /* stream_iterate */
	    strid_t streamref = glk_stream_iterate((strid_t)arglist[0]);
            if ((arglist[1] != null) && (streamref != null))
		arglist[1] = new Integer(glk_stream_get_rock(streamref));
	    arglist[2] = streamref;
            break;
        case 0x0041: /* stream_get_rock */
	    tmpint = glk_stream_get_rock((strid_t)arglist[0]);
	    arglist[1] = new Integer(tmpint);
            break;
        case 0x0042: /* stream_open_file */
            arglist[4] = glk_stream_open_file((frefid_t)arglist[0],
					      IV(arglist[1]), 
					      IV(arglist[2]));
            break;
        case 0x0043: /* stream_open_memory */
	    arrlen = (arglist[0] != null)?((byte [])arglist[0]).length:0;
	    arglist[3] = glk_stream_open_memory((byte [])arglist[0],
						arrlen,
						IV(arglist[1]),
						IV(arglist[2]));
            break;
	case 0x0044: /* stream_close */
            if (arglist[1] != null) {
                stream_result_t dat = new stream_result_t();
		Object [] structargs = (Object [])arglist[1];
                glk_stream_close((strid_t)arglist[0], dat);
                structargs[0] = new Integer(dat.readcount);
                structargs[1] = new Integer(dat.writecount);
            }
            else {
                glk_stream_close((strid_t)arglist[0], null);
            }
            break;
	case 0x0045: /* stream_set_position */
            glk_stream_set_position((strid_t)arglist[0], IV(arglist[1]),
				    IV(arglist[2]));
            break;
        case 0x0046: /* stream_get_position */
	    tmpint = glk_stream_get_position((strid_t)arglist[0]);
            arglist[1] = new Integer(tmpint);
            break;
        case 0x0047: /* stream_set_current */
            glk_stream_set_current((strid_t)arglist[0]);
            break;
        case 0x0048: /* stream_get_current */
            arglist[0] = glk_stream_get_current();
            break;
        case 0x0060: /* fileref_create_temp */
            arglist[2] = glk_fileref_create_temp(IV(arglist[0]), 
						 IV(arglist[1]));
            break;
        case 0x0061: /* fileref_create_by_name */
            arglist[3] = glk_fileref_create_by_name(IV(arglist[0]), 
						    (String)arglist[1],
						    IV(arglist[2]));
            break;
        case 0x0062: /* fileref_create_by_prompt */
            arglist[3] = glk_fileref_create_by_prompt(IV(arglist[0]), 
						      IV(arglist[1]),
						      IV(arglist[2]));
            break;
        case 0x0063: /* fileref_destroy */
            glk_fileref_destroy((frefid_t)arglist[0]);
            break;
        case 0x0064: /* fileref_iterate */
	    frefid_t fileref =  glk_fileref_iterate((frefid_t)arglist[0]);
            if ((arglist[1] != null) && (fileref != null)) {
                tmpint = glk_fileref_get_rock(fileref);
		arglist[1] = new Integer(tmpint);
	    }
	    arglist[2] = fileref;
            break;
	case 0x0065: /* fileref_get_rock */
	    tmpint = glk_fileref_get_rock((frefid_t)arglist[0]);
            arglist[1] = new Integer(tmpint);
            break;
        case 0x0066: /* fileref_delete_file */
            glk_fileref_delete_file((frefid_t)arglist[0]);
            break;
        case 0x0067: /* fileref_does_file_exist */
	    tmpint = glk_fileref_does_file_exist((frefid_t)arglist[0]);
            arglist[0] = new Integer(tmpint);
            break;
        case 0x0068: /* fileref_create_from_fileref */
            arglist[4] = glk_fileref_create_from_fileref(IV(arglist[0]), 
							 (frefid_t)arglist[1],
							 IV(arglist[2]));
            break;
        case 0x0080: /* put_char */
            glk_put_char((char)(((Byte)arglist[0]).intValue()&0xFF));
            break;
        case 0x0081: /* put_char_stream */
            glk_put_char_stream((strid_t)arglist[0],
				(char)(((Byte)arglist[1]).intValue()&0xFF));
            break;
        case 0x0082: /* put_string */
            glk_put_string((String)arglist[0]);
            break;
        case 0x0083: /* put_string_stream */
            glk_put_string_stream((strid_t)arglist[0], (String)arglist[1]);
            break;
        case 0x0084: /* put_buffer */
	    arrlen = (arglist[0] != null)?((byte [])arglist[0]).length:0;
	    glk_put_buffer((byte [])arglist[0], arrlen);
            break;
        case 0x0085: /* put_buffer_stream */
	    arrlen = (arglist[1] != null)?((byte [])arglist[1]).length:0;
	    glk_put_buffer_stream((strid_t)arglist[0],
				  (byte [])arglist[1], arrlen);
            break;
        case 0x0086: /* set_style */
            glk_set_style(IV(arglist[0]));
            break;
        case 0x0087: /* set_style_stream */
            glk_set_style_stream((strid_t)arglist[0], IV(arglist[1]));
            break;
        case 0x0090: /* get_char_stream */
	    tmpint = glk_get_char_stream((strid_t)arglist[0]);
            arglist[1] = new Integer(tmpint);
            break;
        case 0x0091: /* get_line_stream */
	    arrlen = (arglist[1] != null)?((byte [])arglist[1]).length:0;
	    tmpint = glk_get_line_stream((strid_t)arglist[0],
					 (byte [])arglist[2], arrlen);
	    arglist[2] = new Integer(tmpint);
            break;
        case 0x0092: /* get_buffer_stream */
	    arrlen = (arglist[1] != null)?((byte [])arglist[1]).length:0;
	    tmpint = glk_get_buffer_stream((strid_t)arglist[0], 
					   (byte [])arglist[2], arrlen);
	    arglist[2] = new Integer(tmpint);
            break;
        case 0x00A0: /* char_to_lower */
	    char tmpch = glk_char_to_lower((char)(((Byte)arglist[0]).intValue()&0xFF));
            arglist[1] = new Byte((byte)tmpch);
            break;
        case 0x00A1: /* char_to_upper */
	    tmpch = glk_char_to_upper((char)(((Byte)arglist[0]).intValue()&0xFF));
            arglist[1] = new Byte((byte)tmpch);
            break;
        case 0x00B0: /* stylehint_set */
            glk_stylehint_set(IV(arglist[0]), IV(arglist[1]),
			      IV(arglist[2]), IV(arglist[3]));
            break;
        case 0x00B1: /* stylehint_clear */
            glk_stylehint_clear(IV(arglist[0]), IV(arglist[1]),
				IV(arglist[2]));
            break;
        case 0x00B2: /* style_distinguish */
            tmpint = glk_style_distinguish((winid_t)arglist[0], 
					   IV(arglist[1]),
					   IV(arglist[2]));
	    arglist[3] = new Integer(tmpint);
            break;
        case 0x00B3: /* style_measure */
	    Integer tmpInteger = glk_style_measure((winid_t)arglist[0],
						   IV(arglist[1]),
						   IV(arglist[2]));
	    if ((arglist[3] != null) && (tmpInteger != null)) {
		arglist[3] = tmpInteger;
	    }
	    
	    if (tmpInteger == null)
		arglist[4] = new Integer(0);
	    else
		arglist[4] = new Integer(1);
            break;
        case 0x00C0: /* select */
            if (arglist[0] != null) {
                event_t dat = new event_t();
                glk_select(dat);
		Object []structarglist = (Object [])arglist[0];
                structarglist[0] = new Integer(dat.type);
                structarglist[1] = dat.win;
                structarglist[2] = new Integer(dat.val1);
                structarglist[3] = new Integer(dat.val2);
            }
            else {
                glk_select(null);
            }
            break;
    case 0x00C1: /* select_poll */
            if (arglist[0] != null) {
		Object []structarglist = (Object [])arglist[0];
                event_t dat = new event_t();
                glk_select_poll(dat);
                structarglist[0] = new Integer(dat.type);
                structarglist[1] = dat.win;
                structarglist[2] = new Integer(dat.val1);
                structarglist[3] = new Integer(dat.val2);
            }
            else {
                glk_select_poll(null);
            }
            break;
	case 0x00D0: /* request_line_event */
	    arrlen = (arglist[1] != null)?((byte [])arglist[1]).length:0;
	    glk_request_line_event((winid_t)arglist[0], (byte [])arglist[1],
				   arrlen, IV(arglist[2]));
	    break;
	case 0x00D1: /* cancel_line_event */
	    if (arglist[1] != null) {
		Object []structarglist = (Object [])arglist[1];
                event_t dat = new event_t();
                glk_cancel_line_event((winid_t)arglist[0], dat);
                structarglist[0] = new Integer(dat.type);
                structarglist[1] = dat.win;
                structarglist[2] = new Integer(dat.val1);
                structarglist[3] = new Integer(dat.val2);
            }
            else {
                glk_cancel_line_event((winid_t)arglist[0], null);
            }
            break;
        case 0x00D2: /* request_char_event */
            glk_request_char_event((winid_t)arglist[0]);
            break;
        case 0x00D3: /* cancel_char_event */
            glk_cancel_char_event((winid_t)arglist[0]);
            break;
        case 0x00D4: /* request_mouse_event */
            glk_request_mouse_event((winid_t)arglist[0]);
            break;
        case 0x00D5: /* cancel_mouse_event */
            glk_cancel_mouse_event((winid_t)arglist[0]);
            break;
        case 0x00D6: /* request_timer_events */
            glk_request_timer_events(IV(arglist[0]));
            break;
        default:
            /* do nothing */
            break;
	}
  
    }

  public int gidispatch_count_classes()
  {
    return 4;
  }

  public GlkDispatcher(Glk glk) 
  {
    this.glk = glk;
  }
}
