package glk;
abstract public class GlkProxy implements GlkConstants
{
  protected Glk glk;
  
  protected void glk_exit()
  {
    glk.glk_exit();
  }
  
  protected void glk_set_interrupt_handler(GlkInterruptHandler inthandler) 
  {
    glk.glk_set_interrupt_handler(inthandler);
  }
  
  protected void glk_tick() 
  {
    glk.glk_tick();
  }
  
  protected /*glui32*/int glk_gestalt(/*glui32*/int sel, /*glui32*/int val)
  {
    return glk.glk_gestalt(sel, val);
  }
  
  protected /*glui32*/int glk_gestalt_ext(/*glui32*/int sel, /*glui32*/int val, /*glui32*/int []arr, 
					  /*glui32*/int arrlen)
  {
    return glk.glk_gestalt_ext(sel, val, arr, arrlen);
  }
  
  protected char glk_char_to_lower(char ch)
  {
    return glk.glk_char_to_lower(ch);
  }
  
  protected char glk_char_to_upper(char ch)
  {
    return glk.glk_char_to_lower(ch);
  }
  
  protected winid_t glk_window_get_root()
  {
    return glk.glk_window_get_root();
  }
  protected winid_t glk_window_open(winid_t split, /*glui32*/int method, /*glui32*/int size, 
				    /*glui32*/int wintype, /*glui32*/int rock)
  {
    return glk.glk_window_open(split, method, size, wintype, rock);
  }
  
  protected void glk_window_close(winid_t win, stream_result_t result)
  {
    glk.glk_window_close(win, result);
  }
  
  protected glk_size glk_window_get_size(winid_t win)
  {
    return glk.glk_window_get_size(win);
  }
  
  protected void glk_window_set_arrangement(winid_t win, /*glui32*/int method,
					    /*glui32*/int size, winid_t keywin)
  {
	glk.glk_window_set_arrangement(win, method, size, keywin);
  }
  
  protected glk_arrangement glk_window_get_arrangement(winid_t win)
  {
    return glk.glk_window_get_arrangement(win);
  }
  
  protected winid_t glk_window_iterate(winid_t win)
  {
    return glk.glk_window_iterate(win);
  }
  
  protected /*glui32*/int glk_window_get_rock(winid_t win)
  {
    return glk.glk_window_get_rock(win);
  }
  protected /*glui32*/int glk_window_get_type(winid_t win)
  {
    return glk.glk_window_get_type(win);
  }
  protected winid_t glk_window_get_parent(winid_t win)
  {
    return glk.glk_window_get_parent(win);
  }
  protected winid_t glk_window_get_sibling(winid_t win)
  {
    return glk.glk_window_get_sibling(win);
  }
  
  protected void glk_window_clear(winid_t win) 
  {
    glk.glk_window_clear(win);
  }
  
  protected void glk_window_move_cursor(winid_t win, /*glui32*/int xpos, /*glui32*/int ypos) 
    {
      glk.glk_window_move_cursor(win, xpos, ypos);
    }
  
  protected strid_t glk_window_get_stream(winid_t win) {
    return glk.glk_window_get_stream(win);
  }
  
  protected void glk_window_set_echo_stream(winid_t win, strid_t str)
  {
    glk.glk_window_set_echo_stream(win, str);
  }
  
  protected strid_t glk_window_get_echo_stream(winid_t win)
  {
    return glk.glk_window_get_echo_stream(win);
  }
  
  protected void glk_set_window(winid_t win)
  {
    glk.glk_set_window(win);
  }
  
  protected strid_t glk_stream_open_file(frefid_t fileref, /*glui32*/int fmode,
					 /*glui32*/int rock)
  {
    return glk.glk_stream_open_file(fileref, fmode, rock);
  }
  
  protected strid_t glk_stream_open_memory(byte[] buf, /*glui32*/int buflen, /*glui32*/int fmode,
					   /*glui32*/int rock)
  {
    return glk.glk_stream_open_memory(buf, buflen, fmode, rock);
  }
  
  protected void glk_stream_close(strid_t str, stream_result_t result)
  {
    glk.glk_stream_close(str, result);
  }
  
  protected strid_t glk_stream_iterate(strid_t str)
  {
    return glk.glk_stream_iterate(str);
  }
  
  protected /*glui32*/int glk_stream_get_rock(strid_t str)
  {
    return glk.glk_stream_get_rock(str);
  }
  
  protected void glk_stream_set_position(strid_t str, /*glsi32*/int pos, /*glui32*/int seekmode)
  {
    glk.glk_stream_set_position(str, pos, seekmode);
  }
  
  protected /*glui32*/int glk_stream_get_position(strid_t str)
  {
    return glk.glk_stream_get_position(str);
  }
  
  protected void glk_stream_set_current(strid_t str)
  {
    glk.glk_stream_set_current(str);
  }
  
  protected strid_t glk_stream_get_current()
  {
    return glk.glk_stream_get_current();
  }
  
  protected void glk_put_char(char ch)
  {
    glk.glk_put_char(ch);
  }
  
  protected void glk_put_char_stream(strid_t str, char ch)
  {
    glk.glk_put_char_stream(str, ch);
  }
  
  protected void glk_put_string(String s)
  {
    glk.glk_put_string(s);
  }
  
  protected void glk_put_string_stream(strid_t str, String s)
  {
    glk.glk_put_string_stream(str, s);
  }
  
  protected void glk_put_buffer(byte []buf, /*glui32*/int len)
  {
    glk.glk_put_buffer(buf, len);
  }
  protected void glk_put_buffer(char []buf, /*glui32*/int len)
  {
    glk.glk_put_buffer(buf, len);
  }
  protected void glk_put_buffer_stream(strid_t str, byte []buf, /*glui32*/int len)
  {
    glk.glk_put_buffer_stream(str, buf, len);
  }
  protected void glk_put_buffer_stream(strid_t str, char []buf, /*glui32*/int len)
  {
    glk.glk_put_buffer_stream(str, buf, len);
  }
  protected void glk_set_style(/*glui32*/int styl)
  {
    glk.glk_set_style(styl);
  }
  protected void glk_set_style_stream(strid_t str, /*glui32*/int styl)
  {
    glk.glk_set_style_stream(str, styl);
  }
  
  protected int glk_get_char_stream(strid_t str)
  {
    return glk.glk_get_char_stream(str);
  }
  
  protected /*glui32*/int glk_get_line_stream(strid_t str, char []buf, /*glui32*/int len)
  {
    return glk.glk_get_line_stream(str, buf, len);
  }
  
  protected /*glui32*/int glk_get_line_stream(strid_t str, byte []buf, /*glui32*/int len)
  {
    return glk.glk_get_line_stream(str, buf, len);
  }
  
  protected /*glui32*/int glk_get_buffer_stream(strid_t str, char []buf, /*glui32*/int len)
  {
    return glk.glk_get_buffer_stream(str, buf, len);
  }
  
  protected /*glui32*/int glk_get_buffer_stream(strid_t str, byte []buf, /*glui32*/int len)
  {
    return glk.glk_get_buffer_stream(str, buf, len);
  }
  
  protected void glk_stylehint_set(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint, 
				   /*glsi32*/int val)
  {
    glk.glk_stylehint_set(wintype, styl, hint, val);
  }
  
  protected void glk_stylehint_clear(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint)
  {
    glk.glk_stylehint_clear(wintype, styl, hint);
  }
  protected /*glui32*/int glk_style_distinguish(winid_t win, /*glui32*/int styl1, /*glui32*/int styl2)
  {
    return glk.glk_style_distinguish(win, styl1, styl2);
  }
  
  protected /*glui32*/Integer glk_style_measure(winid_t win, /*glui32*/int styl, /*glui32*/int hint)
  {
    return glk.glk_style_measure(win, styl, hint);
  }
  
  protected frefid_t glk_fileref_create_temp(/*glui32*/int usage, /*glui32*/int rock)
  {
    return glk.glk_fileref_create_temp(usage, rock);
  }
  protected frefid_t glk_fileref_create_by_name(/*glui32*/int usage, String name,
						/*glui32*/int rock)
  {
    return glk.glk_fileref_create_by_name(usage, name, rock);
  }
  protected frefid_t glk_fileref_create_by_prompt(/*glui32*/int usage, /*glui32*/int fmode,
						  /*glui32*/int rock)
  {
    return glk.glk_fileref_create_by_prompt(usage, fmode, rock);
  }
  protected frefid_t glk_fileref_create_from_fileref(/*glui32*/int usage, frefid_t fref,
						     /*glui32*/int rock)
  {
    return glk.glk_fileref_create_from_fileref(usage, fref, rock);
  }
  protected void glk_fileref_destroy(frefid_t fref)
  {
    glk.glk_fileref_destroy(fref);
  }
  
  protected frefid_t glk_fileref_iterate(frefid_t fref)  /* can't get the rock here */
  {
    return glk.glk_fileref_iterate(fref);
  }
  
  protected /*glui32*/int glk_fileref_get_rock(frefid_t fref)
  {
    return glk.glk_fileref_get_rock(fref);
  }
  
  protected void glk_fileref_delete_file(frefid_t fref)
  {
    glk.glk_fileref_delete_file(fref);
  }
  
  protected /*glui32*/int glk_fileref_does_file_exist(frefid_t fref)
  {
    return glk.glk_fileref_does_file_exist(fref);
  }
  
  protected void glk_select(event_t event)
  {
    glk.glk_select(event);
  }
  
  protected void glk_select_poll(event_t event)
  {
    glk.glk_select_poll(event);
  }
  
  protected void glk_request_timer_events(/*glui32*/int millisecs)
  {
    glk.glk_request_timer_events(millisecs);
  }
  
  protected void glk_request_line_event(winid_t win, byte []buf, /*glui32*/int maxlen,
					/*glui32*/int initlen)
  {
    glk.glk_request_line_event(win, buf, maxlen, initlen);
  }
  protected void glk_request_char_event(winid_t win)
  {
    glk.glk_request_char_event(win);
  }
  
  protected void glk_request_mouse_event(winid_t win)
  {
    glk.glk_request_mouse_event(win);
  }

  protected void glk_cancel_line_event(winid_t win, event_t event)
  {
    glk.glk_cancel_line_event(win, event);
  }
  
  protected void glk_cancel_char_event(winid_t win)
  {
    glk.glk_cancel_char_event(win);
  }

  protected void glk_cancel_mouse_event(winid_t win)
  {
    glk.glk_cancel_mouse_event(win);
  }
}

