package glk.poorglk;
import glk.*;
import java.util.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;

public class PoorGlk extends Thread implements Glk, GlkDispatch {

    protected GlkInterruptHandler inthandler;
    protected static final int glk_version = 0x00000601;
    protected strid_t current_stream = null;
    protected GlkProgram theprogram;
    protected BufferedReader kbdin;
    protected boolean want_line_events = false;
    protected boolean want_char_events = false;
    protected Object linebuffer_objrock = null;
    protected byte []linebuffer = null;
    static protected final String linebuffer_typecode="&+#!Cn";
    static protected final String memstream_typecode="&+#!Cn";
    protected int linemaxlen = 0;
    protected int linecurlen = 0;
    /*package*/ int screenwidth = 80;
    /*package*/ int screenheight = 24;
    protected GlkObjectRegistry objreg = new GlkNullObjectRegistry();
    protected GlkRetainedRegistry arrayreg = new GlkNullRetainedRegistry();
    String [] passargs = null;
    
    public void glk_exit()
    {
	throw new GlkExitException();
    }
  
    public void glk_set_interrupt_handler(GlkInterruptHandler inthandler)
    {
	this.inthandler = inthandler;
    }
  
    public void glk_tick()
    {
	/* NOTDONE */
    }
  
    public /*glui32*/int glk_gestalt(/*glui32*/int sel, /*glui32*/int val)
    {
	return glk_gestalt_ext(sel,val, null, 0);
    }
  
    public /*glui32*/int glk_gestalt_ext(/*glui32*/int sel, /*glui32*/int val, /*glui32*/int []arr, 
					 /*glui32*/int arrlen)
    {
	switch (sel) {
	case gestalt_Version: 
	    return glk_version;
	case gestalt_LineInput:
	    return can_input_line(val);
	case gestalt_CharInput:
	    return can_input_char(val);
	case gestalt_CharOutput:
	    return can_output(val, (arrlen >= 1)?arr:null);
	case gestalt_MouseInput:
	    return FALSE;
	case gestalt_Timer:
	    return FALSE;
	case gestalt_Graphics:
	    return FALSE;
	case gestalt_DrawImage:
	    return FALSE;
	case gestalt_Sound:
	    return FALSE;
	case gestalt_SoundVolume:
	    return FALSE;
	case gestalt_SoundNotify:
	    return FALSE;
	case gestalt_Hyperlinks:
	    return FALSE;
	case gestalt_HyperlinkInput:
	    return FALSE;
	case gestalt_SoundMusic:
	    return FALSE;
	case gestalt_GraphicsTransparency:
	    return FALSE;
	default:
	    return FALSE;
	}
    }

    protected int can_output(int val, int []arr)
    {
	if (arr != null) arr[0] = 1;
	if ((val >= 32) /* space */ && val <= 126 /* tilde */)
	    return gestalt_CharOutput_ExactPrint;
	if (val == 10) /* newline */
	    return gestalt_CharOutput_ExactPrint;
	/* if ((val >= 160) && (val <= 255)) ... Printing latin1 chars*/
	if (arr != null) arr[0] = 0;
	return gestalt_CharOutput_CannotPrint;
    }
  
    protected int can_input_line(int val) 
    {
	if ((val >= 32) /* space */ && val <= 126 /* tilde */)
	    return TRUE;
	return FALSE;
    }
  
    protected int can_input_char(int val) 
    {
	if (can_input_line(val) == TRUE)
	    return TRUE;
    
	switch (val) {
	case keycode_Return:
	    return TRUE;
	case keycode_Delete:
	    return TRUE;
	case keycode_Escape:
	    return TRUE;
	case keycode_Tab:
	    return TRUE;
	}
    
	return FALSE;
    }
    public char glk_char_to_lower(char ch)
    {
	return Character.toLowerCase(ch);
    }
  
    public char glk_char_to_upper(char ch)
    {
	return Character.toUpperCase(ch);
    }
  
    protected List windowlist = new ArrayList();
  
    public winid_t glk_window_get_root()
    {
	if (windowlist.isEmpty())
	    return null;
	else
	    return (winid_t)windowlist.get(0);
    }

    public winid_t glk_window_open(winid_t split, /*glui32*/int method, /*glui32*/int size, 
				   /*glui32*/int wintype, /*glui32*/int rock)
    {
	PoorWindow newwin;

	if (windowlist.isEmpty()) {
	    if (split != null)
		return null;
	    if (wintype != wintype_TextBuffer)
		return null;
	    newwin = new WinTextBuffer(this, rock);
	    windowlist.add(newwin);
	    newwin.objectrock = objreg.my_vm_reg_object(newwin,
							gidisp_Class_Window);
	    PoorStream newstream = (PoorStream)newwin.get_stream();
	    newstream.objectrock = objreg.my_vm_reg_object(newstream,
							  gidisp_Class_Stream);
	    return newwin;
	}
	else
	    return null;
    }

    public void glk_window_close(winid_t win, stream_result_t result)
    {
	if (!windowlist.remove(win)) {
	    System.err.println("Tried to remove nonexistent window " + win);
	    return;
	}
	objreg.my_vm_unreg_object(win, gidisp_Class_Window, ((PoorWindow)win).objectrock);
	PoorStream oldstream = (PoorStream)((PoorWindow)win).get_stream();
	objreg.my_vm_unreg_object(oldstream, gidisp_Class_Stream, oldstream.objectrock);
	((PoorWindow)win).cleanup(result);
    }

    public glk_size glk_window_get_size(winid_t win)
    {
	return ((PoorWindow)win).get_size();
    }
    public void glk_window_set_arrangement(winid_t win, /*glui32*/int method,
					   /*glui32*/int size, winid_t keywin)
    {
	((PoorWindow)win).set_arrangement(method, size, keywin);
    }
  
    public glk_arrangement glk_window_get_arrangement(winid_t win)
    {
	return ((PoorWindow)win).get_arrangement();
    }
  
    class ObjIterator {
	Iterator it = null;
	Object lastobj = null;
	List l;

	ObjIterator(List nl) {
	    l = nl;
	}
    
	Object next(Object cur) {
	    if ((lastobj != null) && (lastobj == cur)) {
		try {
		    lastobj = it.next();
		    return lastobj;
		}
		catch(NoSuchElementException nsee) {
		    lastobj = null;
		    it = null;
		    return null;
		}
		catch(ConcurrentModificationException cmee) {
		}
	    }
	    if (cur == null) {
		it = l.listIterator();
	    }
	    else {
		int curindex = l.indexOf(cur);
		it = l.listIterator(curindex+1);
	    }
	    if (it.hasNext())
		lastobj = it.next();
	    else {
		lastobj = null;
		it = null;
	    }
	    return lastobj;
	}
    }

    ObjIterator winiterator = new ObjIterator(windowlist);

    public winid_t glk_window_iterate(winid_t win) {
	winid_t result;
	return (winid_t)winiterator.next(win);
    }

    public /*glui32*/int glk_window_get_rock(winid_t win) 
    {
	return ((PoorWindow)win).get_rock();
    }
  
    public /*glui32*/int glk_window_get_type(winid_t win) {
	return ((PoorWindow)win).get_type();
    }

    public winid_t glk_window_get_parent(winid_t win) {
	return ((PoorWindow)win).get_parent();
    }
  
    public winid_t glk_window_get_sibling(winid_t win) {
	return ((PoorWindow)win).get_sibling();
    }
  
    public void glk_window_clear(winid_t win) {
	((PoorWindow)win).clear();
    }

    public void glk_window_move_cursor(winid_t win, /*glui32*/int xpos, /*glui32*/int ypos) {
	((PoorWindow)win).move_cursor(xpos, ypos);
    }

    public strid_t glk_window_get_stream(winid_t win) {
	return ((PoorWindow)win).get_stream();
    }

    public void glk_window_set_echo_stream(winid_t win, strid_t str) {
	((PoorWindow)win).set_echo_stream(str);
    }

    public strid_t glk_window_get_echo_stream(winid_t win) {
	return ((PoorWindow)win).get_echo_stream();
    }

    public void glk_set_window(winid_t win) {
	glk_stream_set_current(((PoorWindow)win).get_stream());
    }

    List streamlist = new ArrayList();
    public strid_t glk_stream_open_file(frefid_t fileref, /*glui32*/int fmode,
					/*glui32*/int rock)
    {
	try {
	    PoorStream newstream = new PoorFileStream(this, fileref, fmode, rock);
	    streamlist.add(newstream);
	    newstream.objectrock = objreg.my_vm_reg_object(newstream,
							gidisp_Class_Stream);
	    return newstream;
	}
	catch (Exception e) {
	    return null;
	}
    }

    public strid_t glk_stream_open_memory(byte[] buf, /*glui32*/int buflen, /*glui32*/int fmode,
					  /*glui32*/int rock)
    {
	try {
	    PoorMemoryStream newstream = new PoorMemoryStream(this, buf, buflen, fmode, rock);
	    streamlist.add(newstream);
	    
	    newstream.objectrock = objreg.my_vm_reg_object(newstream,
							gidisp_Class_Stream);
	    return newstream;
	}
	catch (Exception e) {
	    return null;
	}
    }

    public void glk_stream_close(strid_t str, stream_result_t result) {
	if (!streamlist.remove(str)) {
	    System.err.println("Tried to remove nonexistent stream " + str);
	    return;
	}
	if (current_stream == str)
	    current_stream = null;

	Iterator it = windowlist.iterator();
	while (it.hasNext()) {
	    PoorWindow pw = (PoorWindow)it.next();
	    if (pw.get_echo_stream() == str)
		pw.set_echo_stream(null);

	}
	objreg.my_vm_unreg_object(str, gidisp_Class_Stream, ((PoorStream)str).objectrock);
	((PoorStream)str).cleanup(result);
    }

    ObjIterator streamiterator = new ObjIterator(streamlist);

    public strid_t glk_stream_iterate(strid_t str) {
	return (strid_t)streamiterator.next(str);
    }
  
    public /*glui32*/int glk_stream_get_rock(strid_t str) {
	return ((PoorStream)str).get_rock();
    }

    public void glk_stream_set_position(strid_t str, /*glsi32*/int pos, /*glui32*/int seekmode)
    {
	((PoorStream)str).set_position(pos, seekmode);
    }
  
    public /*glui32*/int glk_stream_get_position(strid_t str) {
	return ((PoorStream)str).get_position();
    }
  
    public void glk_stream_set_current(strid_t str)
    {
	current_stream = str;
    }
  
    public strid_t glk_stream_get_current()
    {
	return current_stream;
    }
  
    public void glk_put_char(char ch) {
	glk_put_char_stream(current_stream, ch);
    }
  
    public void glk_put_char_stream(strid_t str, char ch)
    {
	((PoorStream)str).put_char(ch);
    }

    public void glk_put_string(String s)
    {
	glk_put_string_stream(current_stream, s);
    }
  
    public void glk_put_string_stream(strid_t str, String s) {
	((PoorStream)str).put_string(s);
    }
  
    public void glk_put_buffer(char []buf, /*glui32*/int len) 
    {
	glk_put_buffer_stream(current_stream, buf, len);
    }

    public void glk_put_buffer(byte []buf, /*glui32*/int len) 
    {
	glk_put_buffer_stream(current_stream, buf, len);
    }

    public void glk_put_buffer_stream(strid_t str, char []buf, /*glui32*/int len)
    {
	((PoorStream)str).put_buffer(buf, len);
    }

    public void glk_put_buffer_stream(strid_t str, byte []buf, /*glui32*/int len)
    {
	((PoorStream)str).put_buffer(buf, len);
    }

    public void glk_set_style(/*glui32*/int styl)
    {
	glk_set_style_stream(current_stream, styl);
    }

    public void glk_set_style_stream(strid_t str, /*glui32*/int styl) 
    {
	((PoorStream)str).set_style(styl);
    }
  
    public int glk_get_char_stream(strid_t str)
    {
	return ((PoorStream)str).get_char();
    }
    public /*glui32*/int glk_get_line_stream(strid_t str, char []buf, /*glui32*/int len) 
    {
	return ((PoorStream)str).get_line(buf, len);
    }
  
    public /*glui32*/int glk_get_line_stream(strid_t str, byte []buf, /*glui32*/int len) 
    {
	return ((PoorStream)str).get_line(buf, len);
    }
  
    public /*glui32*/int glk_get_buffer_stream(strid_t str, char []buf, /*glui32*/int len)
    {
	return ((PoorStream)str).get_buffer(buf, len);
    }

    public /*glui32*/int glk_get_buffer_stream(strid_t str, byte []buf, /*glui32*/int len)
    {
	return ((PoorStream)str).get_buffer(buf, len);
    }

    public void glk_stylehint_set(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint, 
				/*glsi32*/int val)
    {
	/* not implemented */;
    }
    public void glk_stylehint_clear(/*glui32*/int wintype, /*glui32*/int styl, /*glui32*/int hint) 
    {
	/* not implemented */;
    }
    public /*glui32*/int glk_style_distinguish(winid_t win, /*glui32*/int styl1, /*glui32*/int styl2)
    {
	return FALSE; /* all styles are the same */
    }
    public /*glui32*/Integer glk_style_measure(winid_t win, /*glui32*/int styl, /*glui32*/int hint)
    {
	return null; /* don't ask me! */
    }
    
    List filereflist = new ArrayList();
    public frefid_t glk_fileref_create_temp(/*glui32*/int usage, /*glui32*/int rock)
    {
	PoorFileRef result = PoorFileRef.create_temp(this, usage, rock);
	if (result != null) {
	    filereflist.add(result);
	    result.objectrock = objreg.my_vm_reg_object(result,
							gidisp_Class_Fileref);
	}
	return result;
    }
    
    public frefid_t glk_fileref_create_by_name(/*glui32*/int usage, String name,
					       /*glui32*/int rock)
    {
	PoorFileRef result = PoorFileRef.create_by_name(this, usage, name, rock);
	if (result != null) {
	    filereflist.add(result);
	    result.objectrock = objreg.my_vm_reg_object(result,
							gidisp_Class_Fileref);
	}
	return result;
    }
    
    public frefid_t glk_fileref_create_by_prompt(/*glui32*/int usage, /*glui32*/int fmode,
						 /*glui32*/int rock)
    {
	PoorFileRef result = PoorFileRef.create_by_prompt(this, usage, fmode, rock);
	if (result != null) {
	    filereflist.add(result);
	    result.objectrock = objreg.my_vm_reg_object(result,
							gidisp_Class_Fileref);
	}
	return result;
    }

    public frefid_t glk_fileref_create_from_fileref(/*glui32*/int usage, frefid_t fref,
						    /*glui32*/int rock)
    {
	PoorFileRef result = PoorFileRef.create_from_fileref(this, usage, fref, rock);
	if (result != null) {
	    filereflist.add(result);
	    result.objectrock = objreg.my_vm_reg_object(result,
							gidisp_Class_Fileref);
	}
	return result;
    }

    public void glk_fileref_destroy(frefid_t fref)
    {
	filereflist.remove(fref);
	objreg.my_vm_unreg_object(fref, gidisp_Class_Fileref, 
				  ((PoorFileRef)fref).objectrock);
	((PoorFileRef)fref).destroy();
    }

    ObjIterator fileref_iterator = new ObjIterator(filereflist);
    public frefid_t glk_fileref_iterate(frefid_t fref)  /* can't get the rock here */
    {
	return (frefid_t)fileref_iterator.next(fref);
    }
    public /*glui32*/int glk_fileref_get_rock(frefid_t fref) 
    {
	return ((PoorFileRef)fref).get_rock();
    }
    public void glk_fileref_delete_file(frefid_t fref)
    {
	((PoorFileRef)fref).delete_file();
    }
    public /*glui32*/int glk_fileref_does_file_exist(frefid_t fref)
    {
	return ((PoorFileRef)fref).does_file_exist();
    }

    public synchronized void glk_select(event_t event) /* interface changed for java */
    {
	try {
	    if (want_char_events) {
		char ch = (char)kbdin.read();
		event.type = evtype_CharInput;
		event.win = (winid_t)windowlist.get(0);
		if (((int)ch & 0x7F) != ch)
		    ch = '?';
		event.val1 = (int)(ch&0x7F);
		event.val2 = 0;
		want_char_events = false;
	    }
	    else if (want_line_events) {
		for (int i = 0; i < linecurlen; i++)
		    System.out.print((char)(linebuffer[i]&0xFF));
		String line_string = kbdin.readLine();
		for (int i = 0; i < line_string.length(); i++) {
		    if (linecurlen >= linemaxlen) break;
		    char ch = line_string.charAt(i);
		    if (((int)ch & 0x7F) != ch)
			ch = '?';
		    linebuffer[linecurlen++] = (byte)ch;
		}
		event.type = evtype_LineInput;
		event.win = (winid_t)windowlist.get(0);
		event.val1 = linecurlen;
		event.val2 = 0;
		want_line_events = false;
		PoorStream es = (PoorStream)((PoorWindow)event.win).get_echo_stream();
		if (es != null) {
		    es.put_buffer(linebuffer, linecurlen);
		    es.put_char('\n');
		}
		arrayreg.my_vm_unreg_array(linebuffer, linecurlen, linebuffer_typecode, linebuffer_objrock);
	    }
	    else {
		System.err.println("Warning: glk program hanging, as requested");
		try {
		    wait();
		}
		catch (InterruptedException ie) {}
	    }
	}
	catch (IOException ioe) {
	    ioe.printStackTrace(System.err);
	}
	
    }

    public void glk_select_poll(event_t event) { 
	/* no internal events in poorglk */
	event.type = evtype_None;
    }

    public void glk_request_timer_events(/*glui32*/int millisecs)
    {
	/*nope, not supporting these */
    }

    public void glk_request_line_event(winid_t win, byte []buf, /*glui32*/int maxlen,
				       /*glui32*/int initlen)
    {
	if (windowlist.contains(win)) {
	    if (want_line_events || want_char_events) 
		System.err.println("Tried to request line events when input already selected");
	    want_line_events = true;
	    want_char_events = false;
	    linebuffer = buf;
	    linemaxlen = maxlen;
	    linecurlen = initlen;
	    linebuffer_objrock = arrayreg.my_vm_reg_array(linebuffer, linemaxlen, linebuffer_typecode);
	}
	else {
	    System.err.println("Wrong window in glk_request_line_event " + win);
	}
    }

    public void glk_request_char_event(winid_t win) 
    {
	if (windowlist.contains(win)) {
	    if (want_line_events || want_char_events) 
		System.err.println("Tried to request char events when input already selected");
	    want_line_events = false;
	    want_char_events = true;
	}
	else {
	    System.err.println("Wrong window in glk_request_char_event " + win);
	}
    }

    public void glk_request_mouse_event(winid_t win)
    {
	/* no mouse */
    }

    public void glk_cancel_line_event(winid_t win, event_t event) 
    {
	if (windowlist.contains(win)) {
	    want_line_events = false;
	    arrayreg.my_vm_unreg_array(linebuffer, linecurlen, linebuffer_typecode, linebuffer_objrock);
	    if (event != null)
		event.type = evtype_None;
	}
	else {
	    System.err.println("Wrong window in glk_cancel_line_event " + win);
	}
    }

    public void glk_cancel_char_event(winid_t win)
    {
	if (windowlist.contains(win)) {
	    want_char_events = false;
	}
	else {
	    System.err.println("Wrong window in glk_cancel_char_event " + win);
	}
    }
    public void glk_cancel_mouse_event(winid_t win)
    {
	/* no mouse */
    }

    /* package */ BufferedReader getKeyboardReader()
    {
	return kbdin;
    }
    
    PoorGlk(GlkProgram myprogram) 
    {
	theprogram = myprogram;
	kbdin = new BufferedReader(new InputStreamReader(System.in));
    }
    
    public void run() 
    {
	try {
	    if (passargs != null)
		((GlkCLStartup)theprogram).glk_commandline_startup(this, passargs);
	    theprogram.glk_main(this);
	}
	catch (GlkExitException gee) {
	}
	finally {
	}
    }

    static public void main(String argv[]) {
	try {
	    GlkProgram theprogram = (GlkProgram)(Class.forName(argv[0]).newInstance());
	    PoorGlk theglk = new PoorGlk(theprogram);
	    if (theprogram instanceof GlkCLStartup) {
		theglk.passargs = new String[argv.length-1];
		System.arraycopy(argv, 1, theglk.passargs, 0,
				 argv.length-1);
	    }
	    theglk.start();
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }
    /* Dispatcher */
    
    public void gidispatch_set_object_registry(GlkObjectRegistry reg) {
	objreg = reg;
    }

    public void gidispatch_set_retained_registry(GlkRetainedRegistry reg) {
	arrayreg = reg;
    }

    public Object gidispatch_get_objrock(Object obj, int objclass) 
    {
	return ((PoorObject)obj).objectrock;
    }

}
