package glk.poorglk;
import glk.*;
class PoorStream extends PoorObject implements strid_t
{
    protected int readchars = 0;
    protected int writechars = 0;
    protected int fmode;

    PoorStream(PoorGlk glk, int fmode, int rock)
    {
	super(glk, rock);
	this.fmode = fmode;
    }
    
    public void put_char(char ch)
    {
	System.err.println("put_char called on illegal stream");
    }

    public void put_string(String s)
    {
	System.err.println("put_string called on illegal stream");
    }

    public void put_buffer(char []buf, int len)
    {
	System.err.println("put_buffer called on illegal stream");
    }
    
    public void put_buffer(byte []buf, int len)
    {
	System.err.println("put_buffer called on illegal stream");
    }
    
    public int get_char()
    {
	System.err.println("get_char called on illegal stream");
	return -1;
    }

    public int get_line(char []buf, int len)
    {
	System.err.println("get_line called on illegal stream");
	return 0;
    }

    public int get_line(byte []buf, int len)
    {
	System.err.println("get_line called on illegal stream");
	return 0;
    }

    public int get_buffer(char []buf, int len)
    {
	System.err.println("get_buffer called on illegal stream");
	return 0;
    }

    public int get_buffer(byte []buf, int len)
    {
	System.err.println("get_line called on illegal stream");
	return 0;
    }

    public void set_style(int styl)
    {
    }

    public void cleanup(stream_result_t result)
    {
	if (result != null) {
	    result.readcount = readchars;
	    result.writecount = writechars;
	}
    }

    public void set_position(int pos, int seekmode)
    {
	System.err.println("set_position called on illegal stream");
    }

    public int get_position()
    {
	return writechars;
    }

}
