package glk.poorglk;
import glk.*;
abstract class PoorWindow extends PoorObject implements winid_t
{
    protected PoorWinStream mystream;
    protected PoorStream echo_stream = null;

    public void cleanup(stream_result_t result)
    {
	mystream.cleanup(result);
    }
    
    public glk_size get_size() {
	glk_size result = new glk_size();
	result.width = glk.screenwidth;
	result.height = glk.screenheight;
	return result;
    }

    protected PoorWindow(PoorGlk glk, int rock) 
    {
	super(glk, rock);
	mystream = new PoorWinStream(glk, this, rock);
    }
    
    public void set_arrangement(int method, int size, winid_t keywin)
    {
	System.err.println("set_arrangement called on non-pair window");
    }

    public glk_arrangement get_arrangement() 
    {
	System.err.println("get_arrangement called on non-pair window");
	return null;
    }

    public abstract int get_type();

    public winid_t get_parent()
    {
	return null;
    }

    public winid_t get_sibling()
    {
	return null;
    }

    public void move_cursor(int xpos, int ypos)
    {
	System.err.println("Warning: move_cursor called on unsupported window");
    }

    public strid_t get_stream()
    {
	return mystream;
    }
    
    public strid_t get_echo_stream()
    {
	return echo_stream;
    }
    
    public void set_echo_stream(strid_t str)
    {
	echo_stream = (PoorStream)str;
    }

    public void clear()
    {
    }
    
    void put_char(char ch)
    {
	if (echo_stream != null)
	    echo_stream.put_char(ch);
    }

    void put_string(String s)
    {
	if (echo_stream != null)
	    echo_stream.put_string(s);
    }

    void put_buffer(char []ch, int len)
    {
	if (echo_stream != null)
	    echo_stream.put_buffer(ch, len);
    }
}
